<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "prospect_practice".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProspectPractice".
 *
 * Columns in table "prospect_practice" available as properties of the model,
 * followed by relations of table "prospect_practice" available as properties of the model.
 *
 * @property integer $id
 * @property integer $prospect_id
 * @property string $name
 * @property string $address
 * @property string $address_2
 * @property string $phone_number
 * @property string $zipcode
 * @property string $city
 * @property string $state
 *
 * @property Prospect $prospect
 * @property ProspectProviderPractice[] $prospectProviderPractices
 */
abstract class BaseProspectPractice extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'prospect_practice';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProspectPractice|ProspectPractices', $n);
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('prospect_id', 'numerical', 'integerOnly'=>true),
            array('name', 'length', 'max'=>150),
            array('address, address_2', 'length', 'max'=>80),
            array('phone_number', 'length', 'max'=>14),
            array('zipcode', 'length', 'max'=>10),
            array('city, state', 'length', 'max'=>50),
            array('prospect_id, name, address, address_2, phone_number, zipcode, city, state', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, prospect_id, name, address, address_2, phone_number, zipcode, city, state', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'prospect' => array(self::BELONGS_TO, 'Prospect', 'prospect_id'),
            'prospectProviderPractices' => array(self::HAS_MANY, 'ProspectProviderPractice', 'prospect_practice_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'prospect_id' => null,
            'name' => Yii::t('app', 'Name'),
            'address' => Yii::t('app', 'Address'),
            'address_2' => Yii::t('app', 'Address 2'),
            'phone_number' => Yii::t('app', 'Phone Number'),
            'zipcode' => Yii::t('app', 'Zipcode'),
            'city' => Yii::t('app', 'City'),
            'state' => Yii::t('app', 'State'),
            'prospect' => null,
            'prospectProviderPractices' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('prospect_id', $this->prospect_id);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('address', $this->address, true);
        $criteria->compare('address_2', $this->address_2, true);
        $criteria->compare('phone_number', $this->phone_number, true);
        $criteria->compare('zipcode', $this->zipcode, true);
        $criteria->compare('city', $this->city, true);
        $criteria->compare('state', $this->state, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
